﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ProxyLayer;

namespace BPMTestApplication
{
    public partial class LoginForm : Form
    {
        public Adapter ProxyAdapter
        {
            get;
            set;
        }
        public string Guid
        {
            get;
            set;
        }

        public LoginForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Gather the information required from the various fields

            // Now call into our adapter, to make the "login"
            try
            {
                ProxyAdapter = new Adapter(usernameBox.Text, passwordBox.Text, hostBox.Text, portBox.Text, useHTTPS.Checked);
                Guid = ProxyAdapter.GetGUID(usernameBox.Text);
                // Login worked, so we return the LoginCredentials object which will be used later
                DialogResult = DialogResult.OK;
                Hide();
            }
            catch (Exception ex)
            {
                // Login failed, display an error dialog with the information
                MessageBox.Show(this, "Error logging in: " + ex.Message, "Error");
            }
        }
    }
}
