﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.Text;

namespace ServiceProxies
{
    //[AttributeUsage(AttributeTargets.Class)]
    public class UsernameBehavior : Attribute, IEndpointBehavior
    {
        #region IEndpointBehavior Members
        private UsernameHeader header;

        public UsernameBehavior(string user, string password)
        {
            header = new UsernameHeader(user, password);
        }

        public void AddBindingParameters(ServiceEndpoint endpoint, System.ServiceModel.Channels.BindingParameterCollection bindingParameters)
        {
        }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, System.ServiceModel.Dispatcher.ClientRuntime clientRuntime)
        {
            CustomMessageInspector inspector = new CustomMessageInspector(header);
            clientRuntime.MessageInspectors.Add(inspector);
        }

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, System.ServiceModel.Dispatcher.EndpointDispatcher endpointDispatcher)
        {
            // Ignore this

        }

        public void Validate(ServiceEndpoint endpoint)
        {
        }

        #endregion
    } 

}
