﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Channels;
using System.Xml;

namespace ServiceProxies
{
    public class UsernameHeader : MessageHeader
    {
        private static String _username, _password;

        private const String Security_Namespace = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd";
        private const String PasswordTest_NameSpace = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText";
        private const String PasswordType_Tag = "Type";
        private const String Security_Tag = "Security";
        private const String UsernameToken_Tag = "UsernameToken";
        private const String Username_Tag = "Username";
        private const String Password_Tag = "Password";

        public UsernameHeader(string user, string password) 
        {
            Username = user;
            Password = password;
        }

        public string Username
        {
            get { return (_username); }
            set { _username = value; }
        }

        public string Password
        {
            get { return (_password); }
            set { _password = value; }
        }

        public override string Name
        {
            get { return (CustomHeaderNames.CustomHeaderName); }
        }

        public override string Namespace
        {
            get { return (CustomHeaderNames.CustomHeaderNamespace); }
        }

        protected override void OnWriteHeaderContents(System.Xml.XmlDictionaryWriter writer, MessageVersion messageVersion)
        {
            // Write the content of the header directly using the XmlDictionaryWriter
            writer.WriteStartElement(UsernameToken_Tag,Security_Namespace);
            writer.WriteStartElement(Username_Tag,Security_Namespace);
            writer.WriteString(Username);
            writer.WriteEndElement();
            writer.WriteStartElement(Password_Tag,Security_Namespace);
            writer.WriteAttributeString(PasswordType_Tag, PasswordTest_NameSpace);
            writer.WriteString(Password);
            writer.WriteEndElement();
            writer.WriteEndElement();
        }

        public UsernameHeader ReadHeader(XmlDictionaryReader reader)
        {
            // Read the header content (key) using the XmlDictionaryReader
            if (reader.ReadToDescendant(CustomHeaderNames.KeyName, CustomHeaderNames.CustomHeaderNamespace))
            {
                String key = reader.ReadElementString();
                return (new UsernameHeader(Username,Password));
            }
            else
            {
                return null;
            }
        }
    }

    public static class CustomHeaderNames
    {
        public const String CustomHeaderName = "Security";

        public const String KeyName = "Key";


        public const String CustomHeaderNamespace = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd";

    } 

}
