﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.ServiceModel;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;

namespace ServiceProxies
{
    public class CustomMessageInspector : IClientMessageInspector
    {
        #region Message Inspector of the Service

        private UsernameHeader _header;

        public CustomMessageInspector(UsernameHeader header)
        {
            _header = header;
        }

        public void BeforeSendReply(ref Message reply, object correlationState)
        {
        }

        #endregion

        #region Message Inspector of the Consumer

        public void AfterReceiveReply(ref Message reply, object correlationState)
        {
        }

        public object BeforeSendRequest(ref Message request, IClientChannel channel)
        {
            // Prepare the request message copy to be modified
            MessageBuffer buffer = request.CreateBufferedCopy(Int32.MaxValue);
            request = buffer.CreateMessage();

            request.Headers.Add(_header);

            return null;
        }

        #endregion
    } 

}
